<?php

noDesignCache();

function showDesignTree($dir,$name,$path)
{	if($name!=template) $class=' class="closed"'; else $class='';
	print '<li'.$class.'><span class="folder">'.$name.'</span><ul>';
	asort($dir);
	foreach($dir as $n => $d)
	{	if(is_array($d)) showDesignTree($d,$n,$path.$name.'/');
		 else
		{	if(substr($d,0,2)=='f:'){
				//print 'file!'.substr($d,2);
				switch(substr($d,-3))
				{	case 'php' : $class='dsphp'; break;
					case 'ini' : $class='dsini'; break;
					case 'tml' : $class='dsske'; break;
					default: $class="file"; break;
				}
				$d = substr($d,2);
				print '<li data-type="file" data-path="'.$path.$name.'/'.$d.'"><span class="'.$class.'">';
				print '<span class="fdel">♻</span>';
				print $d;
				print '<span class="fedit">✎</span>';
				print '</span></li>';
			} else print '<li data-type="redis" data-path="'.$path.$name.'/'.$d.'"><span class="dsrds"><span class="fdel">♻</span>'.$d.'<span class="fedit">✎</span></span></li>';
		}
	}
	print '</ul></li>';
}

AddToHead('

<link rel="stylesheet" type="text/css" href="js/jquery.html/markitup/skins/markitup/style.css" />
<link rel="stylesheet" type="text/css" href="js/jquery.html/markitup/sets/html/style.css" />
<script type="text/javascript" src="js/jquery.html/markitup/jquery.markitup.js"></script>
<script type="text/javascript" src="js/jquery.html/markitup/sets/html/set.js"></script>

');

AddToJs(' function saveFile()
	  {	var value = $("#txtarea").val();
		var dta  = $("#txtarea").data();
		var path  = dta["path"];
		var type  = dta["type"];
		$.get("'.module_path.'/manage/ajax.php?edit="+encodeURIComponent(path)+"&type="+encodeURIComponent(type)+"&data="+encodeURIComponent(value),function(data){ $("#txtareatitle").html(data); });
	  }
');

AddToJquery('

$("span.fdel").click(function()
{	var li = $(this).parent().parent();
	var data = $(li).data();
	var path = data["path"];
	var type = data["type"];
	if(confirm("supprimer "+path+" ?"))
	{	$.get("'.module_path.'/manage/ajax.php?del="+encodeURIComponent(path)+"&type="+encodeURIComponent(type),function(data)
		{	if(data=="ok") $(li).hide("slow"); else $(li).append(" "+data);
		});
	}
});

$("span.fedit").click(function()
{	var li = $(this).parent().parent();
	var data = $(li).data();
	var path = data["path"];
	var type = data["type"];
	$.get("'.module_path.'/manage/ajax.php?edit="+encodeURIComponent(path)+"&type="+encodeURIComponent(type),function(data)
	{	$("#txtarea").val(data).data("path",path).data("type",type);
		$("#txtareatitle").html(type+" "+path);
		$("#ctxtarea").show(1000);
	});
});

$("#txtarea").markItUp(mySettings);

');

function r_scandir($path,&$d,$filter)
{	$l = array_diff(scandir($path),array('.','..'));
	foreach($l as $f)
		if(is_dir($path.'/'.$f))
		{	if(!isset($d[$f])) { $d[$f]=array(); /*print '<br>create folder .. path '.$path.' name : '.$f.'<br>';*/ }
			r_scandir($path.'/'.$f,$d[$f],$filter);
		} else if(($filter)?ereg($filter.'$',$f):1) $d[] = 'f:'.$f;
}

function fn_manage($args)
{	noDesignCache(); // no data cache for this module
	global $redis;
	$keys = redisPrefix.':design:'.template.':*';
	//print '<br>keys : '.$keys;
	$keys = $redis->smembers(redisPrefix.':design:'.template);
	$dirs = array();
	foreach($keys as $key)
	{	$kpath = redisPrefix.':design:'.template.':'.$key;
		$path = explode('/',$key);
		$c = &$dirs;
		$last = count($path)-1;
		foreach($path as $n => $p)
		{	if($n < $last)
			{	if(!isset( $c[$p] )) { $c[$p]=array(); }
				$c = &$c[$p];
			} else { $c[]=$p; }
		}
	}

	r_scandir(template,$dirs,'(php|ini|html)');

	print '<ul id="tree" class="filetree">';
	showDesignTree($dirs,template,'');
	print '</ul><div id="ctxtarea" style="display:none;"><div id="txtareatitle">Titre test</div><textarea id="txtarea"></textarea></div>';
}

?>